#include <Servo.h> 
#include <LiquidCrystal_I2C.h> 
#include <SoftwareSerial.h>

#define Rx_pin 3
#define Tx_pin 4
#define Photorezistor1 A0
#define Photorezistor2 A1

int photoresistor1 = A0; 
int photoresistor2 = A1; 
int UnghiRotire = 90; 
const int eroareAcceptabila = 40; 
float voltage;

Servo servo;
SoftwareSerial BTSerial(Rx_pin, Tx_pin); 
LiquidCrystal_I2C lcd(0x27, 16, 2); 

unsigned long TimpTrecut = 0; 
const long interval = 60000; // 1 minut in MiliSecunde

void setup() {
    BTSerial.begin(9600);
    Serial.begin(9600); 
    servo.attach(11); 
    servo.write(UnghiRotire); 

    lcd.init(); 
    lcd.backlight(); 
    lcd.clear(); 
}

void ShowPower(float voltage) {
    int PowerVar = analogRead(A2);
    voltage = PowerVar * (5.0 / 1023.0); // Calculam tensiunea obtinuta din semnalul analog
    Serial.print("Voltajul este : ");
    Serial.println(voltage); 
    lcd.setCursor(0, 0); 
    lcd.print("Avem Tensiunea de : ");
    lcd.print(voltage); 
    lcd.print(" V");
}

void Bluetooth(float voltage) {
    unsigned long TimpCurent = millis();
    if (TimpCurent - TimpTrecut  >= interval) {
        TimpTrecut = TimCurent;
        BTSerial.print("Am produs tensiunea de: ");
        BTSerial.println(voltage);
    }
}

void findMaxPower(){
  int Fr1 = analogRead(Photorezistor1);
  int Fr2 = analogRead(Photorezistor2);
    
    Serial.print("Fr1: este "); 
    Serial.println(Fr1); 
    Serial.print("Fr2: este"); 
    Serial.println(Fr2); 

    int diff = abs(Fr1 - Fr2);

    if (diff <= eroareAcceptabila) {
        Serial.println("Ambele fotorezistoare primesc lumina intr-o masura egala.");
        servo.detach(); // Oprire fortata pentru servo
    } else {
        if (!servo.attached()) {
            servo.attach(11); // Reatasare servo pe pinul respectiv.
        }
        if (Fr1 < Fr2 && UnghiRotire > 85) {
            UnghiRotire = UnghiRotire - 1;
            if (UnghiRotire < 85) UnghiRotire = 85; 
        } else if (Fr1 > Fr2 && UnghiRotire <=100) {
            UnghiRotire = UnghiRotire + 1;
            if (UnghiRotire > 100) UnghiRotire = 100;
        }
        servo.write(UnghiRotire); 
            delay(80); 
    }
    
}

void loop() {    
    findMaxPower();
    ShowPower(voltage);
    Bluetooth(voltage);
 }   
 
